<?php
/**********************************************************************************
* Blog.php                                                                        *
***********************************************************************************
* SMFBlog: A (very) simple Blog system for Simple Machines Forum                  *
* =============================================================================== *
* Software Version:           SMFBlog 0.1 Beta - $Revision:: 35                 $ *
* $Date:: 2008-02-11 14:23:15 +1100 (Mon, 11 Feb 2008)                          $ *
* Software by:                Daniel15 (http://www.dansoftaustralia.net/)         *
* Copyright 2007 by:          Daniel15 (http://www.dansoftaustralia.net/)         *
*           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
* Support, News, Updates at:  http://mods.simplemachines.org/index.php?mod=793    *
*                                                                                 *
* Forum software by:          Simple Machines (http://www.simplemachines.org)     *
* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
*           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it under   *
* the terms of the provided license as published by Simple Machines LLC.          *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
* See the "license.txt" file for details of the Simple Machines license.          *
* The latest version can always be found at http://www.simplemachines.org.        *
**********************************************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');

/*	This file is for SMFBlog, to view the blog itself.

	void Blog()
		- The main controlling function.
		- just passes control to the correct function
		
	void BlogIndex()
		- shows a list of all the blog boards.
		- if there's only one blog board, redirect straight to it
		
	void BlogView()
		- view a blog itself
		- grabs a list of posts in this blog, via ssi_boardNews()
		
	void BlogViewPost()
		- view a blog post
		- grabs the post and comments via the "SSI Topic and Replies" mod
*/


function Blog()
{
	global $boarddir, $context, $mbname, $modSettings, $scripturl, $settings, $txt;
	
	// Some version stuff
	$context['blog_version'] = array(
		'version' => '1.0-prerelease',
		'build' => '2',
		'revision' => '$Revision: 35 $',
		'date' => '$Date: 2008-02-11 14:23:15 +1100 (Mon, 11 Feb 2008) $',
	);
	
	// Is the blog disabled?
	if (empty($modSettings['blog_enable']))
		// Sorry bud, nothing we can do about this...
		fatal_lang_error('blog_error_disabled');
	
	// Link tree....
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=blog',
		'name' => $txt['blog']
	);
	

	// We need some SSI functions.
	require($boarddir . '/SSI.php');
	// Load our template.
	loadTemplate('Blog');
	// Use the blog layer
	$context['template_layers'][] = 'blog';
	// Add our stylesheet.
	$context['html_headers'] .= '
	<link rel="stylesheet" type="text/css" href="' . $settings['default_theme_url'] . '/blog.css" />';
	// A default page title.
	$context['page_title'] = $mbname . ' &mdash; ' . $txt['blog'];
	
	// Some actions we can do.
	$actions = array(
		'index' => 'BlogIndex',
		'view_blog' => 'BlogView',
		'view_post' => 'BlogViewPost',
	);

	// Get the current action.
	$action = (isset($_GET['sa'])) ? $_GET['sa'] : 'index';

	// Check if the action exist, otherwise go to the index.
	if (isset($actions[$action]))
		$actions[$action]();
	else
		BlogIndex();
}

function BlogIndex()
{
	global $boardurl, $context, $db_prefix, $modSettings, $scripturl, $txt;

	// !!! Todo!
	// Check the user's permissions.
	//isAllowedTo('blog_??');
	
	$context['blog_boards'] = array();
	// Get all the blog boards.
	$result = db_query("
		SELECT ID_BOARD, name, description, blog_alias
		FROM {$db_prefix}boards
		WHERE is_blog = 1
		ORDER BY name ASC", __FILE__, __LINE__);
	
	// Loop through each board...
	while ($row = mysql_fetch_assoc($result))
		// ...Add this board to the list
		$context['blog_boards'][] = array(
			'id' => $row['ID_BOARD'],
			'name' => $row['name'],
			'description' => $row['description'],
			'alias' => $row['blog_alias'],
		);
	mysql_free_result($result);
	
	// Only one board? Let's go straight there
	if (count($context['blog_boards']) == 1)
		redirectexit('action=blog;sa=view_blog;name=' . $context['blog_boards'][0]['alias']);
	
	// Set the page title
	$context['page_title'] .= ' &mdash; ' . $txt['blog_blogs'];
	// Let's go to the index, please :)
	$context['sub_template'] = 'index';
	
}

function BlogView()
{
	global $context, $db_prefix, $scripturl, $txt, $modSettings;
	
	// Do we have an alias?
	if (!empty($_GET['name']))
	{
		// Make sure the alias only has valid characters in it.
		$_GET['name'] = strtolower(preg_replace('/[^A-Za-z0-9\-_]/', '', $_GET['name']));
		// Let's try to get information on this blog.
		$result = db_query("
			SELECT ID_BOARD, name, description, is_blog, blog_alias
			FROM {$db_prefix}boards
			WHERE blog_alias = '$_GET[name]'", __FILE__, __LINE__);
		
	}
	// Otherwise, do we have a numeric board index?
	elseif (!empty($_GET['id']))
	{
		// Make sure ID is numeric.
		$_GET['id'] = (int) $_GET['id'];
		
		// Get some information on this blog board.
		$result = db_query("
			SELECT ID_BOARD, name, description, is_blog, blog_alias
			FROM {$db_prefix}boards
			WHERE ID_BOARD = $_GET[id]", __FILE__, __LINE__);
	}
	// Are you lost? Go back to the beginning.
	else
	{
		redirectexit('action=blog');
	}
	
	// Doesn't exist?
	if (mysql_num_rows($result) == 0)
		fatal_lang_error('blog_error_not_exist');
		
	$row = mysql_fetch_assoc($result);
	mysql_free_result($result);
	
	// Make sure it's a blog.
	if ($row['is_blog'] == false)
		fatal_lang_error('blog_error_not_blog');
		
	// Link tree....
	// Are we using an alias?
	if (!empty($_GET['name']))
	{
		$context['linktree'][] = array(
			'url' => $scripturl . '?action=blog;sa=view_blog;name=' . $_GET['name'],
			'name' => $row['name']
		);
	}
	// Otherwise, it's an ID?
	elseif (!empty($_GET['id']))
	{
		$context['linktree'][] = array(
			'url' => $scripturl . '?action=blog;sa=view_blog;id=' . $_GET['id'],
			'name' => $row['name']
		);
	}
	
	// Set some data that we use.
	$context['blog'] = array(
		'name' => $row['name'],
		'description' => $row['description'],
		'alias' => $row['blog_alias'],
		'posts' => array(),
	);
		
	// Get the number of posts in this board.
	$result = db_query("
		SELECT COUNT(ID_TOPIC)
		FROM {$db_prefix}topics
		WHERE ID_BOARD = {$row['ID_BOARD']}", __FILE__, __LINE__);
	list ($post_count) = mysql_fetch_row($result);
	mysql_free_result($result);
	
	// Construct a page index.
	$context['blog']['pageindex'] = constructPageIndex($scripturl . '?action=blog;sa=view_blog;name=' . $row['blog_alias'] . ';start=%d', $_REQUEST['start'], $post_count, $modSettings['blog_posts_perpage'], true);
	// Get all the recent posts.
	$context['blog']['posts'] = ssi_boardNews($row['ID_BOARD'], $modSettings['blog_posts_perpage'], null, null, array());
		
	// Use the "view" template.
	$context['sub_template'] = 'view';
}

function BlogViewPost()
{
	global $boarddir, $context, $db_prefix, $modSettings, $scripturl, $sourcedir, $txt;
	
	// No ID? Redirect back to the main blog page.
	if (empty($_GET['id']))
		redirectexit('action=blog');
	// Make sure it's numeric.
	$_GET['id'] = (int) $_GET['id'];
	
	// We need the postbox functions.
	require_once($sourcedir . '/Subs-Post.php');
	
	// Register the comment form in the session variables.
	checkSubmitOnce('register');
	
	// Make sure we have a posts per page value. If not, use a default.
	if (empty($modSettings['blog_comments_perpage']))
		$modSettings['blog_comments_perpage'] = 10;
	// Grab the post and its replies.
	$context['blog_post'] = ssi_topic($_GET['id'], $modSettings['blog_comments_perpage'], null, 'array');
	// Construct a page index
	// !!! ssi_topic() should be fixed! :P
	$context['blog_post']['pageindex'] = constructPageIndex($scripturl . '?action=blog;sa=view_post;id=' . $_GET['id'] . (!empty($modSettings['blog_enable_rewrite']) ? ';blog_name=' . $_GET['blog_name'] : '') . ';start=%d#comments', $_REQUEST['start'], $context['blog_post']['reply_count'], $modSettings['blog_comments_perpage'], true);
	
	// If the blog name is passed...
	if (!empty($_GET['blog_name']))
		$context['blog_name'] = $_GET['blog_name'];

	// Use the "view_post" template.
	$context['sub_template'] = 'view_post';
}
?>
